



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Flux demo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Flux demo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 17:41:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><a href="http://www.cnblogs.com/E-WALKER/p/4781819.html" rel="external nofollow noreferrer">Flux demo</a></h1>
<div>
<h2>Introduction</h2>
<p>flux应用架构如下图所示，本文并不是讲述怎么立即做一个酷炫的应用，而是讲述如何依照这种框架，来进行代码的组织。<br /><img referrerpolicy="no-referrer"src="https://files.cnblogs.com/files/E-WALKER/FluxDigram.gif" /><br />我们先把这个流程转述为文字：抛开与webAPI的交互不谈，以后的文章再介绍。<br />flux应用的数据流是单向的，从我们之前最熟悉的React组件看起，它们构成了上图中的React Views。用户交互可以使得Action Creators创建Action，交由Dispatcher分发。根据已注册的Store信息，Dispathcer管理依赖，完成分发，而Store会触发数据改变的事件，侦听该事件的React Views即会进行Store Queries，拿到数据。<br />本文以完成下图的功能为例，一个可以添加item的表单。如果不套flux用的代码少的多，但是，这样的例子适合用于讲解flux而非专注于其它细节(复杂应用将更偏重于React 组件的设计，于本文中心偏离)。<br /><img referrerpolicy="no-referrer"src="https://files.cnblogs.com/files/E-WALKER/react0401.gif" /><br />源码已经上传:<a href="https://github.com/EcutDavid/fluxDemo" rel="external nofollow noreferrer">https://github.com/EcutDavid/fluxDemo</a></p>
<h2>搭建目录，文件结构</h2>
<pre class="prettyprint linenums"><code> mkdir script &amp;&amp; cd script<br />
 mkdir actions components dispatcher stores constants<br />
 cd ..<br />
 touch entry.js index.html webpack.config.js</code></pre>
<p>关于webpack，博主的webpack系列文章已经介绍，再此，不再赘述。<br />安装moudles(关于moudles的选型，仁者见仁，智者见智，无需拘束于以下的例子)。</p>
<pre class="prettyprint linenums"><code>npm init<br />
npm install babel-loader css-loader style-loader flux react keymirror events obejct-assign --save</code></pre>
<h2>Dispatcher</h2>
<p>flux中， Dispatcher是单例的，所以，直接向下面代码一样返回一个实例。之后，Action与Store都会用到它们。</p>
<blockquote><p>script/dispatcher/dispatcher.js</p></blockquote>
<pre class="prettyprint linenums"><code>var Dispatcher = require('flux').Dispatcher;

module.exports = new Dispatcher();</code></pre>
<h2>Action</h2>
<p>实现一个枚举，用于定义所有的Action类型，借助于keymirror实现</p>
<blockquote><p>script/constants/appConstants.js</p></blockquote>
<pre class="prettyprint linenums"><code>var keyMirror = require('keymirror');

module.exports = new keyMirror({<br />
  CREATE: null<br />
});</code></pre>
<p>ActionCreator要借助dispatcher来分发action。</p>
<blockquote><p>script/actions/appActionCreator.js</p></blockquote>
<pre class="prettyprint linenums"><code>"use strict"

var dispatcher = require('../dispatcher/dispatcher');<br />
var appConstants = require('../constants/appConstants');

var appActionCreator = {<br />
  create: function(text) {<br />
    dispatcher.dispatch({<br />
      actionType: appConstants.CREATE,<br />
      text: text<br />
    });<br />
  }<br />
};

module.exports = appActionCreator;</code></pre>
<h2>Store</h2>
<p>Store中，我们需要向dispatcher注册并处理dispatcher分发过来的action，提供接口使得view可以侦听数据变化，查询数据。</p>
<blockquote><p>script/stores/appStore.js</p></blockquote>
<pre class="prettyprint linenums"><code>"use strict"<br />
var dispatcher = require('../dispatcher/dispatcher');<br />
var EventEmitter = require('events').EventEmitter;<br />
var appConstants = require('../constants/appConstants');<br />
var assign = require('object-assign');

var CHANGE_EVENT = 'change';<br />
var textList = [];

var appStore = assign({}, EventEmitter.prototype, {<br />
  create: function(text){<br />
    textList.push(text);<br />
  },<br />
  getAll: function() {<br />
    return textList;<br />
  },<br />
  emitChange: function() {<br />
    this.emit(CHANGE_EVENT);<br />
  },<br />
  addChangeListener: function(callback) {<br />
    this.on(CHANGE_EVENT, callback);<br />
  },<br />
  removeChangeListener: function(callback) {<br />
    this.removeListener(CHANGE_EVENT, callback);<br />
  }<br />
});

dispatcher.register(function(action) {<br />
  switch(action.actionType) {<br />
    case appConstants.CREATE:<br />
      appStore.create(action.text);<br />
      appStore.emitChange();<br />
      break;<br />
    default:<br />
  }<br />
});<br />
</code></pre>
<h2>Views</h2>
<p>在view中，我们侦听store的数据变化，在用户交互时，发出action。</p>
<pre class="prettyprint linenums"><code>"use strict"<br />
var React = require('react');<br />
require('../../style/main.css');<br />
var appActionCreator = require('../actions/appActionCreator');<br />
var appStore = require('../stores/appStore');

var App = React.createClass({<br />
  componentDidMount: function(){<br />
    appStore.addChangeListener(this._onChange);<br />
  },<br />
  componentWillUnmount: function(){<br />
    appStore.removeChangeListener(this._onChange);<br />
  },<br />
  _onChange: function(){<br />
    var arr = appStore.getAll();<br />
    this.setState({'infoList': arr});<br />
  },<br />
  getInitialState:function(){<br />
    var arr = appStore.getAll();<br />
    return({'infoList': arr});<br />
  },<br />
  add: function(){<br />
    appActionCreator.create(React.findDOMNode(this.refs.textArea).value);<br />
  },<br />
  render: function(){<br />
    var textList = this.state.infoList.map(function(item){<br />
      return &lt;p&gt;{item}&lt;/p&gt;;<br />
    });<br />
    return(<br />
      &lt;div className="container"&gt;<br />
        &lt;input ref="textArea" type="text"&gt;&lt;/input&gt;<br />
        &lt;button className="button" onClick={this.add}&gt;add&lt;/button&gt;<br />
        {textList}<br />
      &lt;/div&gt;<br />
    );<br />
  }<br />
});

module.exports = App;</code></pre>
<h2>entry.js</h2>
<pre class="prettyprint linenums"><code>var React = require('react');<br />
var App = require('./script/components/app');

React.render(&lt;App /&gt;, document.body);</code></pre>
<h2>index.html</h2>
<pre class="prettyprint linenums"><code>&lt;!DOCTYPE html&gt;<br />
&lt;html&gt;<br />
  &lt;head&gt;<br />
    &lt;meta charset="utf-8"&gt;<br />
    &lt;title&gt;&lt;/title&gt;<br />
  &lt;/head&gt;<br />
  &lt;body&gt;<br />
    &lt;script src="bundle.js"&gt;&lt;/script&gt;<br />
  &lt;/body&gt;<br />
&lt;/html&gt;</code></pre>
<p>效果：<br /><img referrerpolicy="no-referrer"src="https://files.cnblogs.com/files/E-WALKER/react0402.gif" /><br />dispatcher还可以管理sotre之间的依赖， 借助react，我们还可以开发很多易维护的前端组件。<br />本文是一个完整的flux应用的例子，侧重的是代码，flux的理念请看博主的其它文章 :)</p>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8ep5z91.html">开始我的IT博客之旅</a>
		</li>
						<li><a href="https://www.batexi.com/a/495xl668.html">DedeCMS flink&lowbar;add Getshell漏洞 管理员CSRF漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o4njpq.html">从零开始学 Java - CentOS 下 Nginx &plus; Tomcat 配置负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2wxx8.html">&amp;lt&semi;&amp;lt&semi; CocoaPods安装和使用教程 &amp;gt&semi;&amp;gt&semi;github code4app以及cocoachina 苹果官方文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq40v7n8.html">studio 快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnjm49.html">显示和隐藏Mac下的 隐藏文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde5l7j9.html">如何在Java客户端调用RESTful服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wrmexq.html">ORACLE 查询表定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15jp1q.html">用 PS 调整服务器时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1pv0yq.html">Angular -ui - BootStrap组件的解释以及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1plojq.html">U盘分区后合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkg2ld8.html">python中不能写n&plus;&plus;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z1wyx9.html">TOP-N类查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpw4k79.html">Spring IOC容器对bean的生命周期进行管理的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ry0w28.html">应用程序与驱动程序通信 DeviceIoControl</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdrroj9.html">图文并茂的Python教程-numpy&period;pad</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx6g28.html">Win10更改CMD控制台的代码页和字体和字号</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o402x8.html">visual studio的试用版评估期已结束 解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkgn0v8.html">Mocha 单元测试框架简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppj1d49.html">Codeforces Round &num;501 &lpar;Div&period; 3&rpar; F&period; Bracket Substring</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93yyy2z8.html">centos6&period;5安装nodejs</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pddd1y9.html">Linux游&lpar;1&rpar;&colon; diff&comma; patch和quilt （下一个）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pp0n38.html">［原创］如何编写多个阻塞队列连接下的多生产者多消费者的Python程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yywm08.html">swift－辞典NSDictionary定义&comma;变化的关键&comma;删&sol;加入关键</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pp3lv8.html">svn 使用（一个）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpp5x0q.html">Android在API推荐的方式来实现SQLite数据库的增长、删除、变化、检查操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zznp09.html">HTML介绍JS</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jj0pv8.html">SpringMVC&plus;Spring&plus;Hibernate的小样例</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpp5369.html">&lbrack;MSSQL&rsqb;最小公约数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pddgez9.html">mybatis至mysql插入一个逗号包含值误差</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
